--
-- anna, kobajn ziemniaczany
-- by Lipa 




anna = {};

function anna.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function anna:load(xmlFile)
	self.currentFruitType = FruitUtil.FRUITTYPE_UNKNOWN;
    self.wasToFast = false;
	self.isTurnedOn = false;
	self.fillScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillScale#value"), 1);
	self.beben = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.beben#index"));
	
	


		
end;


function anna:update(dt)
	 if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
            self.isTurnedOn = not self.isTurnedOn;
        end;
    end;
	  self.wasToFast = false;
		if self:getIsActive() then
       
			if self.isTurnedOn and self.fillLevel <= self.capacity then
				rotate(self.beben, dt*0.015, 0, 0 );
		
				
			
            local toFast = self:doCheckSpeedLimit() and self.attacherVehicle.lastSpeed*3600 > 29;
            if not toFast then				
				local area =0;
                for k, cuttingArea in pairs(self.cuttingAreas) do
                    local x,y,z = getWorldTranslation(cuttingArea.start);
                    local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
                    local x2,y2,z2 = getWorldTranslation(cuttingArea.height);

                    for fruitType,v in pairs(self.fillTypes) do
                        if fruitType ~= FruitUtil.FRUITTYPE_UNKNOWN then
							if self.currentFruitType == fruitType or self.currentFruitType == FruitUtil.FRUITTYPE_UNKNOWN then
								local area = Utils.cutFruitArea(fruitType, x, z, x1, z1, x2, z2, 0)
								area = area + Utils.cutFruitArea(fruitType, x, z, x1, z1, x2, z2, 0);
								if area > 0 then
									self.currentFruitType = fruitType;
								end;
								local pixelToQm = 2048 / 4096 * 2048 / 4096  / g_currentMission.maxFruitValue; -- 4096px are mapped to 2048m
								local literPerQm = FruitUtil.fruitIndexToDesc[fruitType].literPerQm * (0.25 * (3 - g_currentMission.missionStats.difficulty));
								local qm = area*pixelToQm;
								local deltaLevel = qm*literPerQm * self.fillScale;
								self:setFillLevel(self.fillLevel+deltaLevel, self.currentFruitType);
							end;
                        end;
                    end;
                end;	
				if self.fillLevel == 0 then
					self.currentFruitType = FruitUtil.FRUITTYPE_UNKNOWN;
				end;			
            end;

            self.wasToFast = toFast;
			
			end;


		end; ---if self:getIsActive() then

	

end;

function anna:mouseEvent(posX, posY, isDown, isUp, button)


end;

function anna:keyEvent(unicode, sym, modifier, isDown)

end;

function anna:draw()
  if self.isTurnedOn then
        g_currentMission:addExtraPrintText("Wcisnij B: Wylacz Anne");
    else
        g_currentMission:addExtraPrintText("Wcisnij B: Wlacz Anne");
    end;
	
end;

function anna:onAttach()
	
end; 	

function anna:onDetach()
	
end;

function anna:onDeactivate()

   
end;

function anna:delete()
	
end;

function anna:onLeave()

end;
 